use strict;
use File::Copy;
# d make script 
# 

our @DSRC = qw(
	pes/byteorder
	pes/wstring
	pes/rc4
	pes/conv
	pes/dump
	pes/prompt
	pes/checksum
	pes/exception
	pes/random
	pes/queue
	pes/file
	pes/variant
	pes/data/sqlite3
	pes/data/stt
	pes/net/winny/nodeaddress
	pes/net/winny/command
	pes/net/winny/connection
	pes/net/winny/cluster
	pes/net/winny/key
	pes/net/util
	pes/system/threadpool
	pes/system/mailbox
	pes/system/semaphore
	pes/system/eventflag
	pes/system/task
	pes/system/locker
	pes/system/delay
	pes/system/singleton
	pes/system/initiation
	pes/system/synchronizer
	pes/btree
	pes/hashtable
	
	common/task
	common/packet
	common/environment
	common/keytable
	common/nodetable
	common/connectiontable
	common/configuration
	common/cacheheadertable
	common/cacheresolve
	common/workertable
	common/downloadlist
	
	task/controltask
	task/linktask
	task/timertask
	task/uitask
	task/uicommand
	task/guitask
	task/keytask
	task/nodetask
	task/querytask
	task/connectiontask
	
	worker/cacheencoder
	worker/cachedecoder
	worker/cachebitmap
	worker/uploader
	worker/downloader
	main
);
# core.def

#our $DMD	= "dmd";
our $DMD	= "dmd";
our $IMPLIB	= "implib/system";
our $OBJDIR	= "obj";
our $DEBUG	= "ui_task";
our $BIN	= "poeny.exe";
our $DFLAGS	= " -op -od$OBJDIR -of$BIN -version=POENY -version=STATIC_UNICODE -version=DFL_UNICODE ";
our $CPLDIR	= ".";

unless ($ARGV[0] eq 'release') {
	$DFLAGS .= " -g  -debug=query_task_d -debug=node_task -debug=connection_task ";
#	$DFLAGS .= " -g -debug=download -debug=ui_task -debug=control_task -debug=key_task -debug=node_task -debug=connection_task -debug=query_task ";
#	$DFLAGS .= " -g -debug=download ";
#	$DFLAGS .= " -g -debug=ui_task -debug=control_task  -debug=node_task -debug=connection_task -debug=cache_task ";
} else {
	print "release mode\n";
	$DFLAGS .= " -inline -O -release core.def ";
#	$DFLAGS .= " -release -inline -O core.def ";
#	$DFLAGS .= "  -debug=ui_task -debug=control_task -debug=key_task -debug=node_task -debug=connection_task -debug=query_task ";
}


chdir($CPLDIR) or die $!;

our $OBJS = undef;

unless (-d $OBJDIR) {
	my @dir = split('/', $OBJDIR);
	my $path;
	$path = undef;
	foreach (@dir) {
		$path .= $_.'/';
		unless (-d $path) {
			mkdir($path) or die "mkdir $path: $!\n";
			warn "note: mkdir $path\n";
		}
	}
}
foreach (@DSRC) {
	my @dir = split('/', $_);
	my $path;
	$#dir--;
	$path = $OBJDIR;
	foreach (@dir) {
		$path .= '/'.$_;
		unless (-d $path) {
			mkdir($path) or die "mkdir $path: $!\n";
			warn "note: mkdir $path\n";
		}
	}
	$OBJS .= ' '.$_;
}

# compile
system("$DMD $OBJS $DFLAGS");;
#copy("core.exe", "..\\poentropy\\core.exe");
#copy("core.exe", "..\\poeny3\\core.exe");
